/* 	Prova 29 Giugno 2006

	Realizzare due classi Thread: "WorkerA" e "WorkerB", ciascuno dei quali
	deve effettuare su di un oggetto condiviso "farm" rispettivamente le
	attivit: "workA" e "workB", per un numero di volte fissato tramite
	il costruttore. La sincronizzazione delle attivit deve essere la seguente:
	- Vanno effettuate sull'oggetto condiviso due attivit di tipo "workA"
	(anche in contemporanea) seguite da un'attivit di tipo "workB".
	Scrivere un programma che crei un oggetto della classe farm ed avvii
	l'esecuzione di 3 thread "WorkerA" e 2 thread "WorkerB".

	Codice: Enrico Saviano http://enrico.saviano.org
*/

class A_060629 {
	public static void main(String args[]) {
		Semaforo A = new Semaforo(2);
		Semaforo B = new Semaforo(0);
		farm fattoria = new farm();
		WorkerA A1 = new WorkerA("A1", 3, fattoria, A, B);
		WorkerA A2 = new WorkerA("A2", 3, fattoria, A, B);
		WorkerA A3 = new WorkerA("A3", 3, fattoria, A, B);
		WorkerB B1 = new WorkerB("B1", 2, fattoria, A, B);
		WorkerB B2 = new WorkerB("B2", 2, fattoria, A, B);
		A1.start(); A2.start(); A3.start();
		B1.start(); B2.start();
	}
}

class farm {
	farm() { }
	public void workA() { System.out.println("Eseguo il workA"); }
	public void workB() { System.out.println("Eseguo il workB"); }
}

class WorkerA extends Thread {
	String nome;
	farm fattoria;
	Semaforo A, B;
	int giri;

	WorkerA (String nome, int giri, farm fattoria, Semaforo A, Semaforo B) {
		this.nome = nome;
		this.fattoria = fattoria;
		this.A = A;
		this.B = B;
		this.giri = giri;
	}
	public void run() {
		while(giri != 0) {
			A.down();
			fattoria.workA(); giri--;
			B.up();
		}
	}
}
class WorkerB extends Thread {
	String nome;
	farm fattoria;
	Semaforo A, B;
	int giri;

	WorkerB (String nome, int giri, farm fattoria, Semaforo A, Semaforo B) {
		this.nome = nome;
		this.fattoria = fattoria;
		this.A = A;
		this.B = B;
		this.giri = giri;
	}
	public void run() {
		while(giri != 0) {
			B.down(); B.down();
			fattoria.workB(); giri--;
			A.up(); A.up();
		}
	}
}