class Semaforo {
	private int value, sospesi;

	Semaforo (int v) {
		value = v;
		sospesi = 0;
	}
	public synchronized void down () {
		if (value == 0) {
			sospesi++;
			try { wait(); } catch (InterruptedException e) {}
			sospesi--;
		}
		else { value--; }
	}
	public synchronized void up () {
		if (sospesi>0)
		{ notify(); }
		else { value++; }
	}
}